(* Load type checking and disentangling code *)

use "dis-tgc.sml"; (* Print depth *)

Control.Print.printDepth := 100;

(*  Channels and values *)

val a = "a"; 
val y = "y";
val v=  "v";
val w=  "w"; 

(* Types *)

val e = Qualified (Un,End);
val t = Channel (e,e);
val tt = Base;
val s = Qualified (Lin,Out(t,Qualified (Lin,In(tt,e))));
val ds = Qualified (Lin,In(t,Qualified (Lin,Out(tt,e))));

(*  Contexts *)

val g = (a,Channel (s,ds))::(w,tt)::[(v,t)]; 

(* Processes *)

val Q = DReplication DZero;

(*  Disentagling process  *)
(* a<v>.a(y).( a<w> | a(j).Q) *)
(*  Nested Session, Single Deadlock *)

val q =  DParallel (DInput ((a,Void,false),"j",DZero),
                      DOutput  ((a,Void,false),DVar (w), Q));
val p =  DOutput  ((a,Void,false),DVar (v), DInput ((a,Void,false),y,q)); 

typeCheckAndResolve(g,p);
