(* Load type checking and disentangling code *)

use "dis-tgc.sml"; 

(* Print depth *)

Control.Print.printDepth := 100;

(*  Channels and values *)

val a = "a";
val b = "b"; 
val y = "y";
val v=  "v";
val w=  "w"; 

(* Types *)

val e = Qualified (Un,End);
val t = Channel (e,e);
val tt = Base;
val sa = Qualified (Lin,Out(t,e));  
val dsa = Qualified (Lin,In(t,e));
val sb = Qualified (Lin,Out(tt,e));
val dsb = Qualified (Lin,In(tt,e));

(*  Contexts *)

val g =  (a,Channel(sa,dsa))::(b,Channel (sb,dsb))::(w,tt)::[(v,t)]; 

(* Processes *)

val Q = DReplication DZero;

(*  Disentagling process *)
(*  a<v>.b(y).b<w>.a(j).Q *)  
(*  2 Flat Sessions, Nested Deadlock *)

val q =  DOutput ((b,Void,false),DVar (w),DInput  ((a,Void,false),"j",Q)); 
val p =  DOutput  ((a,Void,false),DVar (v), DInput ((b,Void,false),y,q));

typeCheckAndResolve(g,p);
