(* Load type checking and disentangling code *)

use "dis-tgc.sml"; 

(* Print depth *)

Control.Print.printDepth := 100;

(*  Channels and values *)

val a = "a";
val y = "y";
val v=  "v";
val w=  "w"; 

(* Types *)

val e = Qualified (Un,End); 
val tt = Base;
val s = Qualified (Lin,Out(tt,e));  
val ds = Qualified (Lin,In(tt,e));
val t = Channel (s,ds);
val sa =  Qualified (Lin,Out(t,e));
val dsa = Qualified (Lin,In(t,e));

(*  Contexts *)

val g =  (a,Channel(sa,dsa))::(w,tt)::[(v,t)]; 

(* Processes *)

val Q = DReplication DZero;

(*  Disentagling process *)
(*  a(y).y<w>.y(z).a<v>.Q *)  
(*  Flat Session with delegation, Nested Deadlock *)

val q =  DInput ((y,Void,false),"z",DOutput  ((a,Void,false),DVar (v),Q)); 
val p =  DInput ((a,Void,false),y, DOutput  ((y,Void,false),DVar (w), q));

typeCheckAndResolve(g,p);
